﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#Event: Result(resMap as Map)
#Event: Error(err as String)

'Class module

Sub Class_Globals
	Private Module As Object
	Private evName As String
	
	Public db As SQL
	
	Private dbDir As String
	Private dbFN As String
End Sub

'Initializes the object. Returns the Me IPLocator object
'Methods 1 and 3 use ip-api.com. Methods 2 and 4 use freegeoip.net
'Check those sites for request rate limits and license restrictions.
Public Sub Initialize(TargetModule As Object, EventName As String, DatabaseDirectory As String, DatabaseFilename As String) As IPLocator
	dbDir = DatabaseDirectory
	dbFN = DatabaseFilename
	db.InitializeSQLite(dbDir, dbFN, True)
	db.ExecNonQuery("CREATE TABLE IF NOT EXISTS ipaddresses (pindex INTEGER PRIMARY KEY, ip TEXT, country TEXT, countrycode TEXT, region TEXT, regionname TEXT, " & _
		"city TEXT, zip TEXT, lat FLOAT, lon FLOAT, timezone TEXT, isp TEXT, org TEXT, autsys TEXT, reverse TEXT, first INTEGER, last INTEGER, numofqueries INTEGER)")
	Module = TargetModule
	evName = EventName
	Return Me
End Sub

'Queries ip-api.com for addr if addr cannot be found in the database.
'Raises EventName_Result with the result.
'Increments numofqueries for that ip record in the database.
Public Sub QueryAddress1(addr As String)
	Dim res As ResultSet = db.ExecQuery("SELECT * FROM ipaddresses WHERE ip=""" & addr & """")
	If res.NextRow Then
		Dim now As Long = DateTime.Now
		db.ExecNonQuery("UPDATE ipaddresses SET numofqueries=numofqueries+1, last=" & now & " WHERE ip=""" & addr & """")
		Dim resMap As Map
		resMap.Initialize
		resMap.Put("ip", addr)
		resMap.Put("country", res.GetString("country"))
		resMap.Put("countrycode", res.GetString("countrycode"))
		resMap.Put("region", res.GetString("region"))
		resMap.Put("regionname", res.GetString("regionname"))
		resMap.Put("city", res.GetString("city"))
		resMap.Put("zip", res.GetString("zip"))
		resMap.Put("lat", res.GetString("lat"))
		resMap.Put("lon", res.GetString("lon"))
		resMap.Put("timezone", res.GetString("timezone"))
		resMap.Put("isp", res.GetString("isp"))
		resMap.Put("org", res.GetString("org"))
		resMap.Put("autsys", res.GetString("autsys"))
		resMap.Put("reverse", res.GetString("reverse"))
		resMap.Put("first", res.GetLong("first"))
		resMap.Put("last", now)
		resMap.Put("numofqueries", res.GetInt("numofqueries")+1)
		CallSubDelayed2(Module, evName & "_Result", resMap)
	Else
		Dim hj As HttpJob
		hj.Initialize("ipapi_0", Me)
		hj.Download("http://ip-api.com/json/" & addr)
	End If
	res.Close
End Sub

'Queries freegoip.net for addr if addr cannot be found in the database.
'Raises EventName_Result with the result.
'Increments numofqueries for that ip record in the database.
Public Sub QueryAddress2(addr As String)
	Dim res As ResultSet = db.ExecQuery("SELECT * FROM ipaddresses WHERE ip=""" & addr & """")
	If res.NextRow Then
		Dim now As Long = DateTime.Now
		db.ExecNonQuery("UPDATE ipaddresses SET numofqueries=numofqueries+1, last=" & now & " WHERE ip=""" & addr & """")
		Dim resMap As Map
		resMap.Initialize
		resMap.Put("ip", addr)
		resMap.Put("country", res.GetString("country"))
		resMap.Put("countrycode", res.GetString("countrycode"))
		resMap.Put("region", res.GetString("region"))
		resMap.Put("regionname", res.GetString("regionname"))
		resMap.Put("city", res.GetString("city"))
		resMap.Put("zip", res.GetString("zip"))
		resMap.Put("lat", res.GetString("lat"))
		resMap.Put("lon", res.GetString("lon"))
		resMap.Put("timezone", res.GetString("timezone"))
		resMap.Put("isp", res.GetString("isp"))
		resMap.Put("org", res.GetString("org"))
		resMap.Put("autsys", res.GetString("autsys"))
		resMap.Put("reverse", res.GetString("reverse"))
		resMap.Put("first", res.GetLong("first"))
		resMap.Put("last", now)
		resMap.Put("numofqueries", res.GetInt("numofqueries")+1)
		CallSubDelayed2(Module, evName & "_Result", resMap)
	Else
		Dim hj As HttpJob
		hj.Initialize("freegeoip_0", Me)
		hj.Download("https://freegeoip.net/json/" & addr)
	End If
	res.Close
End Sub

'Bypasses the database and executes the API call (ip_api.com)
'Raises EventName_Result with the result.
'Increments numofqueries for that ip record in the database.
Public Sub QueryAddress3(addr As String)
	Dim res As ResultSet = db.ExecQuery("SELECT numofqueries FROM ipaddresses WHERE ip=""" & addr & """")
	Dim noq As Int = 0
	If res.NextRow Then
		noq = res.GetInt("numofqueries")
	End If
	res.Close
	Dim hj As HttpJob
	hj.Initialize("ipapi_" & noq, Me)
	hj.Download("http://ip-api.com/json/" & addr)
End Sub

'Bypasses the database and executes the API call (freegoip.net)
'Raises EventName_Result with the result.
'Increments numofqueries for that ip record in the database.
Public Sub QueryAddress4(addr As String)
	Dim res As ResultSet = db.ExecQuery("SELECT numofqueries FROM ipaddresses WHERE ip=""" & addr & """")
	Dim noq As Int = 0
	If res.NextRow Then
		noq = res.GetInt("numofqueries")
	End If
	res.Close
	Dim hj As HttpJob
	hj.Initialize("freegeoip_" & noq, Me)
	hj.Download("https://freegeoip.net/json/" & addr)
End Sub

Private Sub JobDone(Job As HttpJob)
	If Job.Success Then
		Dim jj As JSONParser 
		jj.Initialize(Job.GetString)
		Dim mope As Map = jj.NextObject
		If Job.JobName.Contains("ipapi") Then
			If mope.Get("status")=="fail" Then
				CallSubDelayed2(Module, evName & "_Error", CreateMap("error": mope.Get("message")))
			Else
				Dim now As Long = DateTime.Now
				mope.Put("last", now)
				Dim noq As Int = Regex.Split("_", Job.JobName)(1)+1
				mope.Put("numofqueries", noq)
				If noq==1 Then
					db.ExecNonQuery("INSERT INTO ipaddresses VALUES(null, """ & mope.Get("query") & """,""" & mope.Get("country") & """,""" & mope.Get("countryCode") & _
						""",""" & mope.Get("region") & """,""" & mope.Get("regionName") & """,""" & mope.Get("city") & """,""" & mope.Get("zip") & """," & _
						mope.Get("lat") & "," & mope.Get("lon") & ",""" & mope.Get("timezone") & """,""" & mope.Get("isp") & """,""" & mope.Get("org") & """,""" & _
						mope.Get("as") & """,""" & mope.Get("reverse") & """," & now & "," & now & ", 1 )")
				Else
					db.ExecNonQuery("UPDATE ipaddresses SET numofqueries=numofqueries+1, last=" & now & " WHERE ip=""" & mope.Get("query") & """")		
				End If
				mope.Put("ip", mope.Get("query"))
				mope.Remove("query")
				mope.Remove("status")
				CallSubDelayed2(Module, evName & "_Result", mope)
			End If
		Else If Job.JobName.Contains("freegeoip") Then
			Dim resMap As Map
			resMap.Initialize
			Dim now As Long = DateTime.Now
			Dim noq As Int = Regex.Split("_", Job.JobName)(1)+1

			resMap.Put("last", now)
			resMap.Put("numofqueries", noq)
			resMap.Put("ip", mope.Get("ip"))
			resMap.Put("countrycode", mope.Get("country_code"))
			resMap.Put("country", mope.Get("country_name"))
			resMap.Put("region", mope.Get("region_code"))
			resMap.Put("regionname", mope.Get("region_name"))
			resMap.Put("city", mope.Get("city"))
			resMap.Put("zip", mope.Get("zip_code"))
			resMap.Put("timezone", mope.Get("time_zone"))
			resMap.Put("lat", mope.Get("latitude"))
			resMap.Put("lon", mope.Get("longitude"))
			If noq==1 Then
				db.ExecNonQuery("INSERT INTO ipaddresses VALUES(null, """ & resMap.Get("ip") & """,""" & resMap.Get("country") & """,""" & resMap.Get("countrycode") & _
						""",""" & resMap.Get("region") & """,""" & resMap.Get("regionname") & """,""" & resMap.Get("city") & """,""" & resMap.Get("zip") & """," & _
						resMap.Get("lat") & "," & resMap.Get("lon") & ",""" & resMap.Get("timezone") & """,""" & resMap.Get("isp") & """,""" & resMap.Get("org") & """,""" & _
						resMap.Get("as") & """,""" & resMap.Get("reverse") & """," & now & "," & now & ",1)")
			Else
				db.ExecNonQuery("UPDATE ipaddresses SET numofqueries=numofqueries+1, last=" & now & " WHERE ip=""" & resMap.Get("ip") & """")		
			End If
			CallSubDelayed2(Module, evName & "_Result", resMap)
		End If
	Else
		CallSubDelayed2(Module, evName & "_Error", CreateMap("error" : Job.ErrorMessage))
	End If
	Job.Release
End Sub